diff --git a/include/hw/i386/accel.h b/include/hw/i386/accel.h
index 63d60c7..c294492 100644
--- a/include/hw/i386/accel.h
+++ b/include/hw/i386/accel.h
@@ -4,6 +4,7 @@
 #define HW_I386_ACCEL_H
 
 #include "hw/accel.h"
+#include "qemu/typedefs.h"
 
 #define TYPE_X86_ACCEL "x86-accel"
 
@@ -25,10 +26,16 @@ typedef struct X86Accel {
  *
  * Interface that may be implemented by target-specific accelerator
  * classes.
+ *
+ * @cpu_post_init: Hook called after creation of X86CPU objects. Can be used,
+ *                 to change CPUID data to match accelerator-specific
+ *                 requirements.
  */
 typedef struct X86AccelClass {
     /* <private> */
     InterfaceClass parent;
+    /* <public> */
+    void (*cpu_post_init)(AccelState *accel, X86CPU *cpu, Error **errp);
 } X86AccelClass;
 
 
diff --git a/include/qemu/typedefs.h b/include/qemu/typedefs.h
index 446af93..5879a47 100644
--- a/include/qemu/typedefs.h
+++ b/include/qemu/typedefs.h
@@ -79,4 +79,6 @@ typedef struct PcGuestInfo PcGuestInfo;
 typedef struct Range Range;
 typedef struct AdapterInfo AdapterInfo;
 
+typedef struct X86CPU X86CPU;
+
 #endif /* QEMU_TYPEDEFS_H */
diff --git a/target-i386/cpu.c b/target-i386/cpu.c
index eaae1ce..5fc5762 100644
--- a/target-i386/cpu.c
+++ b/target-i386/cpu.c
@@ -48,6 +48,7 @@
 #include "hw/xen/xen.h"
 #include "hw/i386/apic_internal.h"
 #endif
+#include "hw/i386/accel.h"
 
 
 /* Cache topology CPUID constants: */
@@ -444,31 +445,6 @@ typedef struct model_features_t {
     FeatureWord feat_word;
 } model_features_t;
 
-/* KVM-specific features that are automatically added to all CPU models
- * when KVM is enabled.
- */
-static uint32_t kvm_default_features[FEATURE_WORDS] = {
-    [FEAT_KVM] = (1 << KVM_FEATURE_CLOCKSOURCE) |
-        (1 << KVM_FEATURE_NOP_IO_DELAY) |
-        (1 << KVM_FEATURE_CLOCKSOURCE2) |
-        (1 << KVM_FEATURE_ASYNC_PF) |
-        (1 << KVM_FEATURE_STEAL_TIME) |
-        (1 << KVM_FEATURE_PV_EOI) |
-        (1 << KVM_FEATURE_CLOCKSOURCE_STABLE_BIT),
-    [FEAT_1_ECX] = CPUID_EXT_X2APIC,
-};
-
-/* Features that are not added by default to any CPU model when KVM is enabled.
- */
-static uint32_t kvm_default_unset_features[FEATURE_WORDS] = {
-    [FEAT_1_ECX] = CPUID_EXT_MONITOR,
-};
-
-void x86_cpu_compat_disable_kvm_features(FeatureWord w, uint32_t features)
-{
-    kvm_default_features[w] &= ~features;
-}
-
 /*
  * Returns the set of feature flags that are supported and migratable by
  * QEMU, for a given FeatureWord.
@@ -1998,26 +1974,18 @@ static void x86_cpu_load_def(X86CPU *cpu, X86CPUDefinition *def, Error **errp)
 /* Accelerator-specific initialization code, to be called immediately after
  * creation of the X86CPU object, and before x86_cpu_parse_featurestr().
  */
-static void x86_cpu_accel_init(X86CPU *cpu, Error **errp)
+static void x86_cpu_accel_init(X86CPU *cpu, AccelState *accel, Error **errp)
 {
-    CPUX86State *env = &cpu->env;
     static int inited;
+    X86Accel *xac = X86_ACCEL(object_dynamic_cast(OBJECT(accel),
+                                                  TYPE_X86_ACCEL));
+    X86AccelClass *xacc = NULL;
+    if (xac) {
+        xacc = X86_ACCEL_GET_CLASS(xac);
+    }
 
-    if (kvm_enabled()) {
-        FeatureWord w;
-        for (w = 0; w < FEATURE_WORDS; w++) {
-            env->features[w] |= kvm_default_features[w];
-            env->features[w] &= ~kvm_default_unset_features[w];
-        }
-
-        /* sysenter isn't supported in compatibility mode on AMD,
-         * syscall isn't supported in compatibility mode on Intel.
-         * Normally we advertise the actual CPU vendor, but you can
-         * override this using the 'vendor' property if you want to use
-         * KVM's sysenter/syscall emulation in compatibility mode and
-         * when doing cross vendor migration
-         */
-        object_property_set_str(OBJECT(cpu), "host", "vendor", errp);
+    if (xacc && xacc->cpu_post_init) {
+        xacc->cpu_post_init(accel, cpu, errp);
     }
 
     /* init various static tables used in TCG mode */
@@ -2062,7 +2030,7 @@ X86CPU *cpu_x86_create(const char *cpu_model, DeviceState *icc_bridge,
     }
 
     cpu = X86_CPU(object_new(object_class_get_name(oc)));
-    x86_cpu_accel_init(cpu, &error);
+    x86_cpu_accel_init(cpu, accel, &error);
     if (error) {
         goto out;
     }
diff --git a/target-i386/kvm.c b/target-i386/kvm.c
index 6221794..377e104 100644
--- a/target-i386/kvm.c
+++ b/target-i386/kvm.c
@@ -2593,11 +2593,62 @@ int kvm_device_msix_deassign(KVMState *s, uint32_t dev_id)
                                                 KVM_DEV_IRQ_HOST_MSIX);
 }
 
+/* KVM-specific features that are automatically added to all CPU models
+ * when KVM is enabled.
+ */
+static uint32_t kvm_default_features[FEATURE_WORDS] = {
+    [FEAT_KVM] = (1 << KVM_FEATURE_CLOCKSOURCE) |
+        (1 << KVM_FEATURE_NOP_IO_DELAY) |
+        (1 << KVM_FEATURE_CLOCKSOURCE2) |
+        (1 << KVM_FEATURE_ASYNC_PF) |
+        (1 << KVM_FEATURE_STEAL_TIME) |
+        (1 << KVM_FEATURE_PV_EOI) |
+        (1 << KVM_FEATURE_CLOCKSOURCE_STABLE_BIT),
+    [FEAT_1_ECX] = CPUID_EXT_X2APIC,
+};
+
+/* Features that are not added by default to any CPU model when KVM is enabled.
+ */
+static uint32_t kvm_default_unset_features[FEATURE_WORDS] = {
+    [FEAT_1_ECX] = CPUID_EXT_MONITOR,
+};
+
+void x86_cpu_compat_disable_kvm_features(FeatureWord w, uint32_t features)
+{
+    kvm_default_features[w] &= ~features;
+}
+
+static void x86_kvm_cpu_post_init(AccelState *accel, X86CPU *cpu, Error **errp)
+{
+    CPUX86State *env = &cpu->env;
+    FeatureWord w;
+    for (w = 0; w < FEATURE_WORDS; w++) {
+        env->features[w] |= kvm_default_features[w];
+        env->features[w] &= ~kvm_default_unset_features[w];
+    }
+
+    /* sysenter isn't supported in compatibility mode on AMD,
+     * syscall isn't supported in compatibility mode on Intel.
+     * Normally we advertise the actual CPU vendor, but you can
+     * override this using the 'vendor' property if you want to use
+     * KVM's sysenter/syscall emulation in compatibility mode and
+     * when doing cross vendor migration
+     */
+    object_property_set_str(OBJECT(cpu), "host", "vendor", errp);
+}
+
+static void x86_kvm_accel_class_init(ObjectClass *oc, void *data)
+{
+    X86AccelClass *xacc = X86_ACCEL_CLASS(oc);
+    xacc->cpu_post_init = x86_kvm_cpu_post_init;
+}
+
 #define TYPE_X86_KVM_ACCEL TARGET_NAME "-kvm-accel"
 
 static const TypeInfo x86_kvm_accel_type = {
     .name = TYPE_X86_KVM_ACCEL,
     .parent = TYPE_KVM_ACCEL,
+    .class_init = x86_kvm_accel_class_init,
     .interfaces = (InterfaceInfo[]) {
          { TYPE_X86_ACCEL },
          { }