diff --git a/include/monitor/monitor-system.h b/include/monitor/monitor-system.h
index 3bc7167..5d3827c 100644
--- a/include/monitor/monitor-system.h
+++ b/include/monitor/monitor-system.h
@@ -96,50 +96,4 @@ typedef struct mon_cmd_t {
 int get_expr(Monitor *mon, int64_t *pval, const char **pp);
 int get_double(Monitor *mon, double *pval, const char **pp);
 
-int GCC_FMT_ATTR(2, 3) monitor_fprintf(FILE *stream,
-                                       const char *fmt, ...);
-void help_cmd(Monitor *mon, const char *name);
-void do_help_cmd(Monitor *mon, const QDict *qdict);
-void do_trace_event_set_state(Monitor *mon, const QDict *qdict);
-void do_trace_file(Monitor *mon, const QDict *qdict);
-void do_info_help(Monitor *mon, const QDict *qdict);
-
-void do_info_registers(Monitor *mon, const QDict *qdict);
-void do_info_jit(Monitor *mon, const QDict *qdict);
-void do_info_history(Monitor *mon, const QDict *qdict);
-void tlb_info(Monitor *mon, const QDict *qdict);
-void mem_info(Monitor *mon, const QDict *qdict);
-void do_info_mtree(Monitor *mon, const QDict *qdict);
-void do_info_numa(Monitor *mon, const QDict *qdict);
-void do_info_profile(Monitor *mon, const QDict *qdict);
-void do_info_capture(Monitor *mon, const QDict *qdict);
-void do_info_cpu_stats(Monitor *mon, const QDict *qdict);
-void do_trace_print_events(Monitor *mon, const QDict *qdict);
-void do_logfile(Monitor *mon, const QDict *qdict);
-void do_log(Monitor *mon, const QDict *qdict);
-void do_singlestep(Monitor *mon, const QDict *qdict);
-void do_gdbserver(Monitor *mon, const QDict *qdict);
-void do_memory_dump(Monitor *mon, const QDict *qdict);
-void do_physical_memory_dump(Monitor *mon, const QDict *qdict);
-void do_print(Monitor *mon, const QDict *qdict);
-void do_ioport_read(Monitor *mon, const QDict *qdict);
-void do_ioport_write(Monitor *mon, const QDict *qdict);
-void do_sum(Monitor *mon, const QDict *qdict);
-void do_mouse_move(Monitor *mon, const QDict *qdict);
-void do_mouse_button(Monitor *mon, const QDict *qdict);
-void do_wav_capture(Monitor *mon, const QDict *qdict);
-void do_stop_capture(Monitor *mon, const QDict *qdict);
-void do_boot_set(Monitor *mon, const QDict *qdict);
-int client_migrate_info(Monitor *mon, const QDict *qdict,
-                        MonitorCompletion cb, void *opaque);
-void do_watchdog_action(Monitor *mon, const QDict *qdict);
-void do_acl_show(Monitor *mon, const QDict *qdict);
-void do_acl_policy(Monitor *mon, const QDict *qdict);
-void do_acl_add(Monitor *mon, const QDict *qdict);
-void do_acl_remove(Monitor *mon, const QDict *qdict);
-void do_acl_reset(Monitor *mon, const QDict *qdict);
-void do_inject_mce(Monitor *mon, const QDict *qdict);
-CPUArchState *mon_get_cpu(void);
-void do_loadvm(Monitor *mon, const QDict *qdict);
-
 #endif
diff --git a/monitor-system.c b/monitor-system.c
index 9bbf128..bff158e 100644
--- a/monitor-system.c
+++ b/monitor-system.c
@@ -58,8 +58,8 @@
 
 extern const char *monitor_event_names[];
 
-int GCC_FMT_ATTR(2, 3) monitor_fprintf(FILE *stream,
-                                       const char *fmt, ...)
+static int GCC_FMT_ATTR(2, 3) monitor_fprintf(FILE *stream,
+                                              const char *fmt, ...)
 {
     va_list ap;
     va_start(ap, fmt);
@@ -154,7 +154,7 @@ static void help_cmd_dump(Monitor *mon, const mon_cmd_t *cmds,
     }
 }
 
-void help_cmd(Monitor *mon, const char *name)
+static void help_cmd(Monitor *mon, const char *name)
 {
     char *args[MAX_ARGS];
     int nb_args = 0;
@@ -183,12 +183,12 @@ void help_cmd(Monitor *mon, const char *name)
     free_cmdline_args(args, nb_args);
 }
 
-void do_help_cmd(Monitor *mon, const QDict *qdict)
+static void do_help_cmd(Monitor *mon, const QDict *qdict)
 {
     help_cmd(mon, qdict_get_try_str(qdict, "name"));
 }
 
-void do_trace_event_set_state(Monitor *mon, const QDict *qdict)
+static void do_trace_event_set_state(Monitor *mon, const QDict *qdict)
 {
     const char *tp_name = qdict_get_str(qdict, "name");
     bool new_state = qdict_get_bool(qdict, "option");
@@ -209,7 +209,7 @@ void do_trace_event_set_state(Monitor *mon, const QDict *qdict)
 }
 
 #ifdef CONFIG_TRACE_SIMPLE
-void do_trace_file(Monitor *mon, const QDict *qdict)
+static void do_trace_file(Monitor *mon, const QDict *qdict)
 {
     const char *op = qdict_get_try_str(qdict, "op");
     const char *arg = qdict_get_try_str(qdict, "arg");
@@ -233,7 +233,7 @@ void do_trace_file(Monitor *mon, const QDict *qdict)
 }
 #endif
 
-void do_info_help(Monitor *mon, const QDict *qdict)
+static void do_info_help(Monitor *mon, const QDict *qdict)
 {
     help_cmd(mon, "info");
 }
@@ -251,7 +251,7 @@ int monitor_set_cpu(int cpu_index)
     return 0;
 }
 
-CPUArchState *mon_get_cpu(void)
+static CPUArchState *mon_get_cpu(void)
 {
     if (!cur_mon->mon_cpu) {
         monitor_set_cpu(0);
@@ -266,7 +266,7 @@ int monitor_get_cpu_index(void)
     return cpu->cpu_index;
 }
 
-void do_info_registers(Monitor *mon, const QDict *qdict)
+static void do_info_registers(Monitor *mon, const QDict *qdict)
 {
     CPUState *cpu;
     CPUArchState *env;
@@ -275,12 +275,12 @@ void do_info_registers(Monitor *mon, const QDict *qdict)
     cpu_dump_state(cpu, (FILE *)mon, monitor_fprintf, CPU_DUMP_FPU);
 }
 
-void do_info_jit(Monitor *mon, const QDict *qdict)
+static void do_info_jit(Monitor *mon, const QDict *qdict)
 {
     dump_exec_info((FILE *)mon, monitor_fprintf);
 }
 
-void do_info_history(Monitor *mon, const QDict *qdict)
+static void do_info_history(Monitor *mon, const QDict *qdict)
 {
     int i;
     const char *str;
@@ -297,7 +297,7 @@ void do_info_history(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_info_cpu_stats(Monitor *mon, const QDict *qdict)
+static void do_info_cpu_stats(Monitor *mon, const QDict *qdict)
 {
     CPUState *cpu;
     CPUArchState *env;
@@ -307,13 +307,13 @@ void do_info_cpu_stats(Monitor *mon, const QDict *qdict)
     cpu_dump_statistics(cpu, (FILE *)mon, &monitor_fprintf, 0);
 }
 
-void do_trace_print_events(Monitor *mon, const QDict *qdict)
+static void do_trace_print_events(Monitor *mon, const QDict *qdict)
 {
     trace_print_events((FILE *)mon, &monitor_fprintf);
 }
 
-int client_migrate_info(Monitor *mon, const QDict *qdict,
-                        MonitorCompletion cb, void *opaque)
+static int client_migrate_info(Monitor *mon, const QDict *qdict,
+                               MonitorCompletion cb, void *opaque)
 {
     const char *protocol = qdict_get_str(qdict, "protocol");
     const char *hostname = qdict_get_str(qdict, "hostname");
@@ -346,12 +346,12 @@ int client_migrate_info(Monitor *mon, const QDict *qdict,
     return -1;
 }
 
-void do_logfile(Monitor *mon, const QDict *qdict)
+static void do_logfile(Monitor *mon, const QDict *qdict)
 {
     qemu_set_log_filename(qdict_get_str(qdict, "filename"));
 }
 
-void do_log(Monitor *mon, const QDict *qdict)
+static void do_log(Monitor *mon, const QDict *qdict)
 {
     int mask;
     const char *items = qdict_get_str(qdict, "items");
@@ -368,7 +368,7 @@ void do_log(Monitor *mon, const QDict *qdict)
     qemu_set_log(mask);
 }
 
-void do_singlestep(Monitor *mon, const QDict *qdict)
+static void do_singlestep(Monitor *mon, const QDict *qdict)
 {
     const char *option = qdict_get_try_str(qdict, "option");
     if (!option || !strcmp(option, "on")) {
@@ -380,7 +380,7 @@ void do_singlestep(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_gdbserver(Monitor *mon, const QDict *qdict)
+static void do_gdbserver(Monitor *mon, const QDict *qdict)
 {
     const char *device = qdict_get_try_str(qdict, "device");
     if (!device)
@@ -396,7 +396,7 @@ void do_gdbserver(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_watchdog_action(Monitor *mon, const QDict *qdict)
+static void do_watchdog_action(Monitor *mon, const QDict *qdict)
 {
     const char *action = qdict_get_str(qdict, "action");
     if (select_watchdog_action(action) == -1) {
@@ -555,7 +555,7 @@ static void memory_dump(Monitor *mon, int count, int format, int wsize,
     }
 }
 
-void do_memory_dump(Monitor *mon, const QDict *qdict)
+static void do_memory_dump(Monitor *mon, const QDict *qdict)
 {
     int count = qdict_get_int(qdict, "count");
     int format = qdict_get_int(qdict, "format");
@@ -565,7 +565,7 @@ void do_memory_dump(Monitor *mon, const QDict *qdict)
     memory_dump(mon, count, format, size, addr, 0);
 }
 
-void do_physical_memory_dump(Monitor *mon, const QDict *qdict)
+static void do_physical_memory_dump(Monitor *mon, const QDict *qdict)
 {
     int count = qdict_get_int(qdict, "count");
     int format = qdict_get_int(qdict, "format");
@@ -575,7 +575,7 @@ void do_physical_memory_dump(Monitor *mon, const QDict *qdict)
     memory_dump(mon, count, format, size, addr, 1);
 }
 
-void do_print(Monitor *mon, const QDict *qdict)
+static void do_print(Monitor *mon, const QDict *qdict)
 {
     int format = qdict_get_int(qdict, "format");
     hwaddr val = qdict_get_int(qdict, "val");
@@ -601,7 +601,7 @@ void do_print(Monitor *mon, const QDict *qdict)
     monitor_printf(mon, "\n");
 }
 
-void do_sum(Monitor *mon, const QDict *qdict)
+static void do_sum(Monitor *mon, const QDict *qdict)
 {
     uint32_t addr;
     uint16_t sum;
@@ -620,7 +620,7 @@ void do_sum(Monitor *mon, const QDict *qdict)
 
 static int mouse_button_state;
 
-void do_mouse_move(Monitor *mon, const QDict *qdict)
+static void do_mouse_move(Monitor *mon, const QDict *qdict)
 {
     int dx, dy, dz, button;
     const char *dx_str = qdict_get_str(qdict, "dx_str");
@@ -644,7 +644,7 @@ void do_mouse_move(Monitor *mon, const QDict *qdict)
     qemu_input_event_sync();
 }
 
-void do_mouse_button(Monitor *mon, const QDict *qdict)
+static void do_mouse_button(Monitor *mon, const QDict *qdict)
 {
     static uint32_t bmap[INPUT_BUTTON_MAX] = {
         [INPUT_BUTTON_LEFT]       = MOUSE_EVENT_LBUTTON,
@@ -661,7 +661,7 @@ void do_mouse_button(Monitor *mon, const QDict *qdict)
     mouse_button_state = button_state;
 }
 
-void do_ioport_read(Monitor *mon, const QDict *qdict)
+static void do_ioport_read(Monitor *mon, const QDict *qdict)
 {
     int size = qdict_get_int(qdict, "size");
     int addr = qdict_get_int(qdict, "addr");
@@ -695,7 +695,7 @@ void do_ioport_read(Monitor *mon, const QDict *qdict)
                    suffix, addr, size * 2, val);
 }
 
-void do_ioport_write(Monitor *mon, const QDict *qdict)
+static void do_ioport_write(Monitor *mon, const QDict *qdict)
 {
     int size = qdict_get_int(qdict, "size");
     int addr = qdict_get_int(qdict, "addr");
@@ -717,7 +717,7 @@ void do_ioport_write(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_boot_set(Monitor *mon, const QDict *qdict)
+static void do_boot_set(Monitor *mon, const QDict *qdict)
 {
     int res;
     const char *bootdevice = qdict_get_str(qdict, "bootdevice");
@@ -883,7 +883,7 @@ static void tlb_info_64(Monitor *mon, CPUArchState *env)
 }
 #endif
 
-void tlb_info(Monitor *mon, const QDict *qdict)
+static void tlb_info(Monitor *mon, const QDict *qdict)
 {
     CPUArchState *env;
 
@@ -1106,7 +1106,7 @@ static void mem_info_64(Monitor *mon, CPUArchState *env)
 }
 #endif
 
-void mem_info(Monitor *mon, const QDict *qdict)
+static void mem_info(Monitor *mon, const QDict *qdict)
 {
     CPUArchState *env;
 
@@ -1145,8 +1145,9 @@ static void print_tlb(Monitor *mon, int idx, tlb_t *tlb)
                    tlb->d, tlb->wt);
 }
 
-void tlb_info(Monitor *mon, const QDict *qdict)
+static void tlb_info(Monitor *mon, const QDict *qdict)
 {
+
     CPUArchState *env = mon_get_cpu();
     int i;
 
@@ -1161,7 +1162,7 @@ void tlb_info(Monitor *mon, const QDict *qdict)
 #endif
 
 #if defined(TARGET_SPARC) || defined(TARGET_PPC) || defined(TARGET_XTENSA)
-void tlb_info(Monitor *mon, const QDict *qdict)
+static void tlb_info(Monitor *mon, const QDict *qdict)
 {
     CPUArchState *env1 = mon_get_cpu();
 
@@ -1169,12 +1170,12 @@ void tlb_info(Monitor *mon, const QDict *qdict)
 }
 #endif
 
-void do_info_mtree(Monitor *mon, const QDict *qdict)
+static void do_info_mtree(Monitor *mon, const QDict *qdict)
 {
     mtree_info((fprintf_function)monitor_printf, mon);
 }
 
-void do_info_numa(Monitor *mon, const QDict *qdict)
+static void do_info_numa(Monitor *mon, const QDict *qdict)
 {
     int i;
     CPUState *cpu;
@@ -1198,7 +1199,7 @@ void do_info_numa(Monitor *mon, const QDict *qdict)
 int64_t qemu_time;
 int64_t dev_time;
 
-void do_info_profile(Monitor *mon, const QDict *qdict)
+static void do_info_profile(Monitor *mon, const QDict *qdict)
 {
     monitor_printf(mon, "async time  %" PRId64 " (%0.3f)\n",
                    dev_time, dev_time / (double)get_ticks_per_sec());
@@ -1208,7 +1209,7 @@ void do_info_profile(Monitor *mon, const QDict *qdict)
     dev_time = 0;
 }
 #else
-void do_info_profile(Monitor *mon, const QDict *qdict)
+static void do_info_profile(Monitor *mon, const QDict *qdict)
 {
     monitor_printf(mon, "Internal profiler not compiled\n");
 }
@@ -1217,7 +1218,7 @@ void do_info_profile(Monitor *mon, const QDict *qdict)
 /* Capture support */
 static QLIST_HEAD (capture_list_head, CaptureState) capture_head;
 
-void do_info_capture(Monitor *mon, const QDict *qdict)
+static void do_info_capture(Monitor *mon, const QDict *qdict)
 {
     int i;
     CaptureState *s;
@@ -1228,7 +1229,7 @@ void do_info_capture(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_stop_capture(Monitor *mon, const QDict *qdict)
+static void do_stop_capture(Monitor *mon, const QDict *qdict)
 {
     int i;
     int n = qdict_get_int(qdict, "n");
@@ -1244,7 +1245,7 @@ void do_stop_capture(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_wav_capture(Monitor *mon, const QDict *qdict)
+static void do_wav_capture(Monitor *mon, const QDict *qdict)
 {
     const char *path = qdict_get_str(qdict, "path");
     int has_freq = qdict_haskey(qdict, "freq");
@@ -1279,7 +1280,7 @@ static qemu_acl *find_acl(Monitor *mon, const char *name)
     return acl;
 }
 
-void do_acl_show(Monitor *mon, const QDict *qdict)
+static void do_acl_show(Monitor *mon, const QDict *qdict)
 {
     const char *aclname = qdict_get_str(qdict, "aclname");
     qemu_acl *acl = find_acl(mon, aclname);
@@ -1297,7 +1298,7 @@ void do_acl_show(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_acl_reset(Monitor *mon, const QDict *qdict)
+static void do_acl_reset(Monitor *mon, const QDict *qdict)
 {
     const char *aclname = qdict_get_str(qdict, "aclname");
     qemu_acl *acl = find_acl(mon, aclname);
@@ -1308,7 +1309,7 @@ void do_acl_reset(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_acl_policy(Monitor *mon, const QDict *qdict)
+static void do_acl_policy(Monitor *mon, const QDict *qdict)
 {
     const char *aclname = qdict_get_str(qdict, "aclname");
     const char *policy = qdict_get_str(qdict, "policy");
@@ -1328,7 +1329,7 @@ void do_acl_policy(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_acl_add(Monitor *mon, const QDict *qdict)
+static void do_acl_add(Monitor *mon, const QDict *qdict)
 {
     const char *aclname = qdict_get_str(qdict, "aclname");
     const char *match = qdict_get_str(qdict, "match");
@@ -1359,7 +1360,7 @@ void do_acl_add(Monitor *mon, const QDict *qdict)
     }
 }
 
-void do_acl_remove(Monitor *mon, const QDict *qdict)
+static void do_acl_remove(Monitor *mon, const QDict *qdict)
 {
     const char *aclname = qdict_get_str(qdict, "aclname");
     const char *match = qdict_get_str(qdict, "match");
@@ -1376,7 +1377,7 @@ void do_acl_remove(Monitor *mon, const QDict *qdict)
 }
 
 #if defined(TARGET_I386)
-void do_inject_mce(Monitor *mon, const QDict *qdict)
+static void do_inject_mce(Monitor *mon, const QDict *qdict)
 {
     X86CPU *cpu;
     CPUState *cs;
@@ -1400,7 +1401,7 @@ void do_inject_mce(Monitor *mon, const QDict *qdict)
 }
 #endif
 
-void do_loadvm(Monitor *mon, const QDict *qdict)
+static void do_loadvm(Monitor *mon, const QDict *qdict)
 {
     int saved_vm_running  = runstate_is_running();
     const char *name = qdict_get_str(qdict, "name");